﻿using MongoDB.Bson;
using MongoDB.Bson.Serialization.Attributes;
using MongoDB.Driver;
using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using YamlDotNet.Serialization;

namespace MongoExpressionConvert
{
    public abstract class CustomFilter<TEntity>
    {
        public abstract Expression<Func<TEntity, bool>> GetMongoFilter();

        public static CustomFilter<TEntity> Equal<TField>(Expression<Func<TEntity, TField>> property, TField value) 
            => new EqualFilter<TEntity, TField>(property, value);

        public static CustomFilter<TEntity> ListContains<TField>(Expression<Func<TEntity, List<TField>>> property, TField value) 
            => new ListContainsFilter<TEntity, TField>(property, value);
    }
}
