﻿using System;
using System.Linq.Expressions;

namespace MongoExpressionConvert
{
    public class EqualFilter<TEntity, TField> : CustomFilter<TEntity>
    {
        public EqualFilter(Expression<Func<TEntity, TField>> property, TField value)
        {
            Property = property;
            Value = value;
        }

        public Expression<Func<TEntity, TField>> Property { get; }
        public TField Value { get; }

        public override Expression<Func<TEntity, bool>> GetMongoFilter() => ExpressionHelpers.ConvertToEqual(Property, Value);
    }
}
