﻿using MongoDB.Bson;
using MongoDB.Bson.Serialization.Attributes;
using MongoDB.Driver;
using System;
using System.Collections.Generic;
using System.Linq.Expressions;
using YamlDotNet.Serialization;

namespace MongoExpressionConvert
{

    public class ListContainsFilter<TEntity, TField> : CustomFilter<TEntity>
    {
        public ListContainsFilter(Expression<Func<TEntity, List<TField>>> property, TField value)
        {
            Property = property;
            Value = value;
        }

        public Expression<Func<TEntity, List<TField>>> Property { get; }
        public TField Value { get; }

        public override Expression<Func<TEntity, bool>> GetMongoFilter() => ExpressionHelpers.ConvertToListPropertyContains(Property, Value);
    }
}
